﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Selenium;

#if DEBUG
using Microsoft.VisualStudio.TestTools.UnitTesting;
using TestFixture = Microsoft.VisualStudio.TestTools.UnitTesting.TestClassAttribute;
using SetUp = Microsoft.VisualStudio.TestTools.UnitTesting.TestInitializeAttribute;
using TearDown = Microsoft.VisualStudio.TestTools.UnitTesting.TestCleanupAttribute;
using Test = Microsoft.VisualStudio.TestTools.UnitTesting.TestMethodAttribute;
#else
using NUnit.Framework;
#endif

namespace SeleniumUnitTests
{
    public abstract class AspNetWikiTests : SeleniumBase
    {
        [TestFixture]
        public class Firefox : AspNetWikiTests
        {
            [SetUp]
            public void SetupTest()
            {
                selenium = new DefaultSelenium("localhost", 4444, "*firefox", "http://www.aspnetwiki.com/");
                selenium.Start();
                verificationErrors = new StringBuilder();
            }
        }

        [TestFixture]
        public class IExplorer : AspNetWikiTests
        {
            [SetUp]
            public void SetupTest()
            {
                HttpCommandProcessor proc = new HttpCommandProcessor("localhost", 4444, "*iexplore", "http://www.aspnetwiki.com/");
                selenium = new DefaultSelenium(proc);
                selenium.Start();
                verificationErrors = new StringBuilder();
                selenium.UseXpathLibrary("javascript-xpath");
            }
        }

        [TearDown]
        public void TeardownTest()
        {
            try
            {
                selenium.Stop();
            }
            catch (Exception)
            {
                // Ignore errors if unable to close the browser
            }
            Assert.AreEqual("", verificationErrors.ToString());
        }

        [Test]
        public void SearchForSeleniumArticle()
        {
            selenium.Open("/");
            selenium.Type("search-top-box-input", "Selenium");
            selenium.Click("search");
            Assert.IsTrue(this.WaitForXpathCount("//a[@href='http://www.aspnetwiki.com/testing-asp-net-applications-with-selenium']"));
            selenium.Click("link=Testing ASP.NET Applications with Selenium");
            selenium.WaitForPageToLoad("30000");
            Assert.AreEqual("Testing ASP.NET Applications with Selenium", selenium.GetText("//div[@id='page-title']").Trim());
        }
    }
}
