﻿using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using Selenium;

namespace SeleniumUnitTests
{
    public abstract class SeleniumBase
    {
        protected ISelenium selenium;
        protected StringBuilder verificationErrors;

        /// <summary>
        /// Wait until the xpath count equals the count passed in or the timeout is reached.
        /// </summary>
        /// <param name="xpath">xpath to evaluate.</param>
        /// <param name="timeout">number of seconds to wait.</param>
        /// <param name="count">number of occurances to find.</param>
        /// <returns>true if the number of xpath occurances is equal to the count passed in.</returns>
        protected bool WaitForXpathCount(string xpath, int timout = 60, int count = 1)
        {
            bool found = false;

            for (int second = 0; ; second++)
            {
                if (second >= timout)
                {
                    break;
                }

                try
                {
                    if (count == selenium.GetXpathCount(xpath))
                    {
                        found = true;
                        break;
                    }
                }
                catch (Exception)
                {
                }
                Thread.Sleep(1000);
            }
            return found;
        }
    }
}
